## ros-noetic-cras-cpp-common 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.2)
project(cras_cpp_common)

set(CMAKE_CXX_STANDARD 17)  # allows better Eigen alignment handling

find_package(catkin REQUIRED COMPONENTS
  bondcpp
  class_loader
  diagnostic_msgs
  diagnostic_updater
  dynamic_reconfigure
  filters
  geometry_msgs
  nodelet
  pluginlib
  rosconsole
  roscpp
  rosgraph_msgs
  sensor_msgs
  std_msgs
  tf2
  tf2_eigen
  tf2_geometry_msgs
  tf2_ros
  tf2_sensor_msgs
  topic_tools
)

# find pthread and provide it as Threads::Threads imported target
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

find_package(Boost REQUIRED COMPONENTS thread)

find_package(Eigen3 REQUIRED)

find_package(urdfdom_headers REQUIRED)

# Require https://github.com/ros/filters/pull/60 in the filters package (added in 1.8.3 and 1.9.2)
#catkin_lint: ignore_once duplicate_find
find_package(filters QUIET)
if(filters_VERSION VERSION_LESS 1.9.0)
  if(filters_VERSION VERSION_LESS 1.8.3)
    message(FATAL_ERROR "Please update package 'filters' to version 1.8.3 or newer.")
  endif()
else()
  if(filters_VERSION VERSION_LESS 1.9.2)
    message(FATAL_ERROR "Please update package 'filters' to version 1.9.2 or newer.")
  endif()
endif()

generate_dynamic_reconfigure_options(
  cfg/FilterChain.cfg
)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    bondcpp
    class_loader
    diagnostic_msgs
    diagnostic_updater
    dynamic_reconfigure
    filters
    geometry_msgs
    nodelet
    pluginlib
    rosconsole
    roscpp
    sensor_msgs
    tf2
    tf2_ros
    topic_tools
  DEPENDS
    Boost
    EIGEN3
    urdfdom_headers
  LIBRARIES
    cras_c_api
    cras_cloud
    cras_diag_updater
    cras_diag_utils
    cras_log_utils
    cras_node_utils
    cras_nodelet_manager
    cras_nodelet_manager_sharing_tf_buffer
    cras_nodelet_utils
    cras_param_utils
    cras_rate_limiter
    cras_semaphore
    cras_string_utils
    cras_tf2_sensor_msgs
    cras_tf2_utils
    cras_thread_utils
    cras_time_utils
    cras_type_utils
    cras_urdf_utils
  CFG_EXTRAS
    ${PROJECT_NAME}-extras.cmake
    ${PROJECT_NAME}-node_from_nodelet.cmake
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
try_compile(HAS_FROM_CHARS_FLOAT
  ${CMAKE_BINARY_DIR}/from_chars ${CMAKE_CURRENT_SOURCE_DIR}/cmake/from_chars_try_compile.cpp
  CXX_STANDARD 17)
try_compile(HAS_DESIGNATED_INITIALIZERS
  ${CMAKE_BINARY_DIR}/designated_initializers ${CMAKE_CURRENT_SOURCE_DIR}/cmake/designated_initializers_try_compile.cpp
  CXX_STANDARD 17)

set(CCC_INCLUDE_BASE "${CMAKE_CURRENT_SOURCE_DIR}/include/${PROJECT_NAME}")

add_library(cras_any INTERFACE)
target_sources(cras_any INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/any.hpp>)
target_sources(cras_any INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/any-lite/any.hpp>)

add_library(cras_expected INTERFACE)
target_sources(cras_expected INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/expected.hpp>)
target_sources(cras_expected INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tl/expected.hpp>)

add_library(cras_functional INTERFACE)
target_sources(cras_functional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/functional.hpp>)
target_sources(cras_functional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/invoke.hpp/invoke.hpp>)

add_library(cras_optional INTERFACE)
target_sources(cras_optional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/optional.hpp>)
target_sources(cras_optional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tl/optional.hpp>)

add_library(cras_c_api src/c_api.cpp)

add_library(cras_semaphore src/thread_utils/semaphore.cpp)

add_library(cras_set_utils INTERFACE)
target_sources(cras_set_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/set_utils.hpp>)

add_library(cras_type_traits INTERFACE)
target_sources(cras_type_traits INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/type_utils/string_traits.hpp>)

add_library(cras_literal_sz INTERFACE)
target_sources(cras_type_traits INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/type_utils/literal_sz.h>)

add_library(cras_urdf_utils src/urdf_utils.cpp)
#catkin_lint: ignore_once external_interface_path
target_include_directories(cras_urdf_utils PUBLIC ${urdfdom_headers_INCLUDE_DIRS})
target_link_libraries(cras_urdf_utils
  PUBLIC Eigen3::Eigen)

add_library(cras_pool_allocator INTERFACE)
target_sources(cras_pool_allocator INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/pool_allocator.hpp>)
target_link_libraries(cras_pool_allocator
  INTERFACE Boost::boost)

add_library(cras_message_utils INTERFACE)
target_sources(cras_message_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/message_utils.hpp>)
target_link_libraries(cras_message_utils
  INTERFACE ${catkin_LIBRARIES})
add_dependencies(cras_message_utils INTERFACE ${catkin_EXPORTED_TARGETS})

add_library(cras_cloud src/cloud.cpp)
add_dependencies(cras_cloud ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_cloud
  PUBLIC ${catkin_LIBRARIES})

add_library(cras_diag_updater src/diag_utils/updater.cpp)
add_dependencies(cras_diag_updater ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_diag_updater
  PUBLIC ${catkin_LIBRARIES})

add_library(cras_nodelet_manager
  src/nodelet_utils/loader_ros.cpp
  src/nodelet_utils/nodelet_manager.cpp)
add_dependencies(cras_nodelet_manager ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_nodelet_manager
  PUBLIC ${catkin_LIBRARIES} Boost::boost Boost::thread)

add_library(cras_math_utils INTERFACE)
target_sources(cras_math_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/math_utils.hpp>)
target_sources(cras_math_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/math_utils/running_stats.hpp>)
target_sources(cras_math_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/math_utils/running_stats_duration.hpp>)
target_link_libraries(cras_math_utils
  INTERFACE ${catkin_LIBRARIES})

add_library(cras_time_utils
  src/time_utils.cpp
  src/time_utils/interruptible_sleep_interface.cpp)
target_link_libraries(cras_time_utils
  PUBLIC ${catkin_LIBRARIES}
  PRIVATE cras_semaphore Boost::boost)

add_library(cras_rate_limiter src/rate_limiter.cpp)
target_link_libraries(cras_rate_limiter
  PUBLIC ${catkin_LIBRARIES}
  PRIVATE cras_time_utils)

add_library(cras_tf2_utils
  src/tf2_utils.cpp
  src/tf2_utils/interruptible_buffer.cpp)
add_dependencies(cras_tf2_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_tf2_utils
  PUBLIC cras_thread_utils cras_time_utils ${catkin_LIBRARIES})

add_library(cras_string_utils src/string_utils.cpp src/string_utils/from_chars.cpp)
add_dependencies(cras_string_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_string_utils
  PUBLIC cras_time_utils cras_type_traits ${catkin_LIBRARIES})
if (HAS_FROM_CHARS_FLOAT)
  target_compile_definitions(cras_string_utils PRIVATE HAS_FROM_CHARS_FLOAT=1)
endif()

add_library(cras_thread_utils src/thread_utils.cpp)
target_link_libraries(cras_thread_utils
  PRIVATE cras_string_utils Threads::Threads)

add_library(cras_log_utils src/log_utils.cpp src/log_utils/memory.cpp src/log_utils/node.cpp src/log_utils/nodelet.cpp)
target_link_libraries(cras_log_utils
  PUBLIC cras_string_utils ${catkin_LIBRARIES} PRIVATE cras_time_utils)

add_library(cras_tf2_sensor_msgs src/tf2_sensor_msgs.cpp)
add_dependencies(cras_tf2_sensor_msgs ${catkin_EXPORTED_TARGETS})
target_compile_options(cras_tf2_sensor_msgs PRIVATE -march=native)
target_link_libraries(cras_tf2_sensor_msgs
  PUBLIC ${catkin_LIBRARIES}
  PRIVATE cras_cloud cras_string_utils Eigen3::Eigen)

add_library(cras_type_utils src/type_utils.cpp)
target_link_libraries(cras_type_utils
  PUBLIC cras_type_traits cras_literal_sz
  PRIVATE cras_string_utils)

add_library(cras_test_utils INTERFACE)
target_sources(cras_test_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/test_utils/preloading_class_loader.hpp>)
target_link_libraries(cras_test_utils
  INTERFACE cras_type_utils ${catkin_LIBRARIES})

add_library(xmlrpc_value_traits INTERFACE)
target_sources(xmlrpc_value_traits INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/xmlrpc_value_traits.hpp>)
target_link_libraries(xmlrpc_value_traits
  INTERFACE cras_string_utils ${catkin_LIBRARIES})

add_library(xmlrpc_value_utils INTERFACE)
target_sources(xmlrpc_value_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/xmlrpc_value_utils.hpp>)
target_link_libraries(xmlrpc_value_utils
  INTERFACE xmlrpc_value_traits)

add_library(cras_param_utils
  src/param_utils/get_param_adapters/node_handle.cpp
  src/param_utils/get_param_adapters/xmlrpc_value.cpp)
target_sources(cras_param_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/param_utils.hpp>)
add_dependencies(cras_param_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_param_utils
  PUBLIC cras_log_utils cras_optional cras_string_utils cras_type_utils xmlrpc_value_utils ${catkin_LIBRARIES}
  PRIVATE xmlrpc_value_traits)

add_library(cras_filter_base INTERFACE)
target_sources(cras_filter_base INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/filter_utils/filter_base.hpp>)
target_link_libraries(cras_filter_base
  INTERFACE cras_log_utils cras_param_utils cras_string_utils ${catkin_LIBRARIES})

add_library(cras_filter_chain INTERFACE)
target_sources(cras_filter_chain INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/filter_utils/filter_chain.hpp>)
target_link_libraries(cras_filter_chain
  INTERFACE cras_filter_base cras_log_utils cras_string_utils cras_type_utils ${catkin_LIBRARIES} Boost::boost)

add_library(cras_diag_utils
  src/diag_utils/duration_status.cpp
  src/diag_utils/duration_status_param.cpp
  src/diag_utils/topic_diagnostic.cpp
  src/diag_utils/topic_status_param.cpp)
add_dependencies(cras_diag_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_diag_utils
  PUBLIC cras_diag_updater cras_log_utils cras_math_utils cras_message_utils cras_optional
    cras_param_utils cras_time_utils cras_type_utils ${catkin_LIBRARIES} Boost::boost)

add_library(cras_node_utils
  src/node_utils/node_handle_with_diagnostics.cpp
  src/node_utils/param_helper.cpp)
target_sources(cras_node_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/node_utils.hpp>)
add_dependencies(cras_node_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_node_utils
  PUBLIC cras_diag_utils cras_log_utils cras_message_utils cras_optional cras_param_utils cras_string_utils
    ${catkin_LIBRARIES} Boost::boost)

add_library(cras_nodelet_utils
  src/nodelet_utils/nodelet_aware_tf_buffer.cpp
  src/nodelet_utils/stateful_nodelet.cpp)
target_sources(cras_nodelet_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/nodelet_utils.hpp>)
target_sources(cras_nodelet_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/nodelet_utils/log_macros.h>)
target_sources(cras_nodelet_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/nodelet_utils/nodelet_with_diagnostics.hpp>)
target_sources(cras_nodelet_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/nodelet_utils/param_helper.hpp>)
target_sources(cras_nodelet_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/nodelet_utils/thread_name_updating_nodelet.hpp>)
add_dependencies(cras_nodelet_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_nodelet_utils
  PUBLIC cras_diag_updater cras_diag_utils cras_log_utils cras_message_utils cras_node_utils cras_param_utils
    cras_string_utils cras_thread_utils cras_time_utils cras_tf2_utils ${catkin_LIBRARIES} Boost::boost)

add_library(cras_filter_chain_nodelet INTERFACE)
target_sources(cras_filter_chain_nodelet INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/filter_chain_nodelet.hpp>)
add_dependencies(cras_filter_chain_nodelet INTERFACE ${${PROJECT_NAME}_EXPORTED_TARGETS})
target_link_libraries(cras_filter_chain_nodelet
  INTERFACE cras_diag_utils cras_filter_chain cras_functional cras_nodelet_utils cras_string_utils
    ${catkin_LIBRARIES} Boost::thread)
