=== debian/changelog ===
ros-noetic-cras-cpp-common (2.1.2-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 09 Feb 2023 23:00:00 -0000

ros-noetic-cras-cpp-common (2.1.1-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-cpp-common (2.1.0-1buster) buster; urgency=high

  * log_utils: Added a method to set logger to HasLogger class.
  * c_api: Added outputRosMessage() method that directly serializes ROS messages into allocated buffers.
  * log_utils: Added MemoryLogHelper, reworked the interface of LogHelper a bit.
  * Completely reworked log_utils to use macros instead of functions.
    This was needed because of the static log_location variables inside ROS_ macros - e.g. _ONCE was only triggered once regardless of where was it called from. There were also not so helpful file:line data in the logged messages.
    Backwards compatibility was kept 99%, but there are subtle cases where it will fail - e.g. if there was this->log->logError() right after an if or else without braces.
  * Added c_api.h.
  * Added cras::expected.
  * Fixed doxygen configuration and a few documentation errors.
    To get a clean rosdoc_lite run, set
    INPUT_FILTER = "sed 's/([ <])::/1/g'"
    in doxy.template in rosdoc_lite .
  * xmlrpc_value_utils: Added conversion to dynamic_reconfigure/Config message.
  * string_utils: Added cras::strip().
  * Added std::any shim.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.10-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.9-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.8-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.7-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.6-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.5-1buster) buster; urgency=high

  * Added support for std::array parameters.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 22 Oct 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.4-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Oct 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.3-1buster) buster; urgency=high

  * cras_py_common: Extended functionality to get closer to cras_cpp_common.
  * Improved readmes and added more badges to them.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 06 Oct 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.2-1buster) buster; urgency=high

  * De-flake throttle test and enable catkin_lint when it has chance to run correctly.
  * Add linters and licenses.
  * Set up roslaunch-check for test files.
  * added catkin_lint
  * added roslint, fixed issues.
  * catkin_lint, moved external folder inside include/project to avoid collisions with other projects.
  * Avoid threading errors when stopping nodes created by node_from_nodelet.
  * time_utils: Fix build on 32bit armhf.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 28 Aug 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.1-1buster) buster; urgency=high

  * Added LICENSE file.
  * Improved node_from_nodelet to use node logger instead of nodelet logger.
  * Added Github Actions CI.
  * Increased test coverage, fixed bug in filter diagnostics.
  * tf2_utils: Added convenience methods getRoll(), getPitch() and getYaw().
  * filter_utils: Adapt to upstream changes adding FilterChain::getFilters() method.
  * string_utils: Allowed to limit replace() only to the beginning or end of the string.
  * string_utils: Added parseDouble() and friends.
  * node_from_nodelet.cmake: Made autogenerated target names less prone to naming conflicts.
  * Added more logging function variants.
  * Added support for std::string format in LogHelper.
  * Fix logging macros to log under correct rosconsole logger.
  * Added cras_node_from_nodelet() CMake function.
  * Better support for custom data types in getParam() functions.
  * Rename test targets so that their names do not conflict with other projects.
  * Compatibility with GCC 9+.
  * Fixed invalid rate conversion.
  * Backwards compatibility for StatefulNodelet::shutdown().
  * Improved CMakeLists.txt and header guard placement.
  * Merged cras_nodelet_topic_tools with cras_topic_tools, moved repeater and joy_repeater from cras_cpp_common to cras_topic_tools.
  * Implemented rate limiters.
  * Refactored nodelet_manager_sharing_tf_buffer and added tests for it.
  * Added urdf_utils.h.
  * Improved tf2_sensor_msgs.h and added test.
  * Improved set_utils.hpp.
  * Added better shim for std::optional. It now provides all relevant features.
  * Added more diagnostics to filter_chain_nodelet.hpp.
  * Added shim for std::bind_front into functional.hpp.
  * Added running_stats.hpp implementing Welford's running mean and variance computation.
  * Improved filter_chain_nodelet.hpp, added tests.
  * Improved cloud.hpp, added tests.
  * Reorganize filter_utils directory structure.
  * Improved the interface of diag_utils and node_utils, added tests. Added message_utils.
  * Improved the interface of nodelet_utils, added tests. Added thread_utils with tests.
  * XmlRpcValue docs and code reliability.
  * Better test coverage of param_utils. Improved Eigen getParam() interface.
  * Improved getParam() behavior, added test_param_utils.
  * First part of upgrade: log_utils, param_utils, filter_utils, node_utils, xmlrpc, cloud.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 25 Aug 2022 22:00:00 -0000
