## ros-noetic-cras-cpp-common 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.7.2)
+cmake_minimum_required(VERSION 3.10.2)
 project(cras_cpp_common)
 
 set(CMAKE_CXX_STANDARD 17)  # allows better Eigen alignment handling
@@ -132,6 +132,10 @@
 target_sources(cras_optional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/optional.hpp>)
 target_sources(cras_optional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tl/optional.hpp>)
 
+add_library(cras_span INTERFACE)
+target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/span.hpp>)
+target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tcb/span.hpp>)
+
 add_library(cras_c_api src/c_api.cpp)
 
 add_library(cras_semaphore src/thread_utils/semaphore.cpp)
@@ -303,6 +307,3 @@
 target_sources(cras_filter_chain_nodelet INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/filter_chain_nodelet.hpp>)
 add_dependencies(cras_filter_chain_nodelet INTERFACE ${${PROJECT_NAME}_EXPORTED_TARGETS})
 target_link_libraries(cras_filter_chain_nodelet
-  INTERFACE cras_diag_utils cras_filter_chain cras_functional cras_nodelet_utils cras_string_utils
-    ${catkin_LIBRARIES} Boost::thread)
-
