=== debian/changelog ===
ros-noetic-cras-cpp-common (2.3.1-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 12 Jul 2023 22:00:00 -0000

ros-noetic-cras-cpp-common (2.3.0-1focal) focal; urgency=high

  * Increased minimum CMake version to 3.10.2.
  * log_utils: Fixed a potential segfault when instances of MemoryLogHelper get recycled.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 11 Jul 2023 22:00:00 -0000

ros-noetic-cras-cpp-common (2.2.3-1focal) focal; urgency=high

  * Install node_from_nodelet targets in PACKAGE_BIN and not GLOBAL_BIN
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 15 Jun 2023 22:00:00 -0000

ros-noetic-cras-cpp-common (2.2.2-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 14 May 2023 22:00:00 -0000

ros-noetic-cras-cpp-common (2.2.1-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 14 May 2023 22:00:00 -0000

ros-noetic-cras-cpp-common (2.2.0-1focal) focal; urgency=high

  * Fixed parseFloat()/parseDouble() tests to reflect the behavior change in fast_float library.
  * Update fast_float to v4.0.
  * Update fast_float to v3.10.0.
  * Update tl/expected.
  * Update tl/optional to v1.1.0.
  * string_utils: Added toLower/toUpper.
  * Added std::span shim.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 08 Apr 2023 22:00:00 -0000

ros-noetic-cras-cpp-common (2.1.2-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 09 Feb 2023 23:00:00 -0000

ros-noetic-cras-cpp-common (2.1.1-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-cpp-common (2.1.0-1focal) focal; urgency=high

  * log_utils: Added a method to set logger to HasLogger class.
  * c_api: Added outputRosMessage() method that directly serializes ROS messages into allocated buffers.
  * log_utils: Added MemoryLogHelper, reworked the interface of LogHelper a bit.
  * Completely reworked log_utils to use macros instead of functions.
    This was needed because of the static log_location variables inside ROS_ macros - e.g. _ONCE was only triggered once regardless of where was it called from. There were also not so helpful file:line data in the logged messages.
    Backwards compatibility was kept 99%, but there are subtle cases where it will fail - e.g. if there was this->log->logError() right after an if or else without braces.
  * Added c_api.h.
  * Added cras::expected.
  * Fixed doxygen configuration and a few documentation errors.
    To get a clean rosdoc_lite run, set
    INPUT_FILTER = "sed 's/([ <])::/1/g'"
    in doxy.template in rosdoc_lite .
  * xmlrpc_value_utils: Added conversion to dynamic_reconfigure/Config message.
  * string_utils: Added cras::strip().
  * Added std::any shim.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.10-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.9-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.8-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.7-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.6-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-cpp-common (2.0.5-1focal) focal; urgency=high

  * Added support for std::array parameters.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 22 Oct 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.4-1focal) focal; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Oct 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.3-1focal) focal; urgency=high

  * cras_py_common: Extended functionality to get closer to cras_cpp_common.
  * Improved readmes and added more badges to them.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 06 Oct 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.2-1focal) focal; urgency=high

  * De-flake throttle test and enable catkin_lint when it has chance to run correctly.
  * Add linters and licenses.
  * Set up roslaunch-check for test files.
  * added catkin_lint
  * added roslint, fixed issues.
  * catkin_lint, moved external folder inside include/project to avoid collisions with other projects.
  * Avoid threading errors when stopping nodes created by node_from_nodelet.
  * time_utils: Fix build on 32bit armhf.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 28 Aug 2022 22:00:00 -0000

ros-noetic-cras-cpp-common (2.0.1-1focal) focal; urgency=high

  * Added LICENSE file.
  * Improved node_from_nodelet to use node logger instead of nodelet logger.
  * Added Github Actions CI.
  * Increased test coverage, fixed bug in filter diagnostics.
  * tf2_utils: Added convenience methods getRoll(), getPitch() and getYaw().
  * filter_utils: Adapt to upstream changes adding FilterChain::getFilters() method.
  * string_utils: Allowed to limit replace() only to the beginning or end of the string.
  * string_utils: Added parseDouble() and friends.
  * node_from_nodelet.cmake: Made autogenerated target names less prone to naming conflicts.
  * Added more logging function variants.
  * Added support for std::string format in LogHelper.
  * Fix logging macros to log under correct rosconsole logger.
  * Added cras_node_from_nodelet() CMake function.
  * Better support for custom data types in getParam() functions.
  * Rename test targets so that their names do not conflict with other projects.
  * Compatibility with GCC 9+.
  * Fixed invalid rate conversion.

