=== debian/control ===
Source: ros-noetic-cras-cpp-common
Section: misc
Priority: optional
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libeigen3-dev, liburdfdom-headers-dev, python3-catkin-lint <!nocheck>, ros-noetic-bondcpp, ros-noetic-catkin, ros-noetic-class-loader, ros-noetic-diagnostic-msgs, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-filters, ros-noetic-geometry-msgs, ros-noetic-nodelet, ros-noetic-pluginlib, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-rosgraph-msgs, ros-noetic-roslaunch <!nocheck>, ros-noetic-roslint <!nocheck>, ros-noetic-rostest <!nocheck>, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-tf2-sensor-msgs, ros-noetic-topic-tools
Homepage: https://wiki.ros.org/cras_cpp_common
Standards-Version: 3.9.2

Package: ros-noetic-cras-cpp-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, liburdfdom-headers-dev, ros-noetic-bondcpp, ros-noetic-class-loader, ros-noetic-diagnostic-msgs, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-filters, ros-noetic-geometry-msgs, ros-noetic-nodelet, ros-noetic-pluginlib, ros-noetic-rosconsole, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-ros, ros-noetic-topic-tools
Description: A Czech-army knife for ROS code written in C++.
